#include "phys.h"
#include <gl.h>
#include <stdio.h>
#include <device.h>

float dt;
float ks, kd;
float friction, resilience;
float maz, cks, ckd;
int iterations;

void RandomParts(float &xr,float &yr,float &zr) {
	xr = (drand48() - 0.5) * 10;
	yr = drand48() * 5 + 10;
	zr = (drand48() - 0.5) * 10;
}

main()
{


	cout << "Spring Constant1, Spring Damping1, Spring Constant2, Spring Damping2 friction resilience mass dt Iterations per draw" << endl;

	scanf("%f %f %f %f %f %f %f %f %d", &ks, &kd, &cks, &ckd, &friction, &resilience, &maz, &dt, &iterations);

	cout << "Controls:" << endl;
	cout << "W-A-S-Z for orientation of view" << endl;
	cout << "E-X     for zoom in and out" << endl;
	cout << "SPACE   for re-init shape" << endl;

	prefsize(512,512);
	winopen("Dyna");
	RGBmode();
	doublebuffer();

	zbuffer(TRUE);
	gconfig();
	mmode(MVIEWING);
	perspective(450,1, 0.01, 1000);
	lookat(0,1,15,0,0,0,0);
	linewidth(5);


/**************************/
	connections *allConnections = new connections;

	particleSystem *allParticles = new particleSystem;


	/* Make 1 particle */
	particle *part = new particle;
	part->AssignPosition(1,7,-1);
	part->AssignVelocity(0,0,0);
	part->AssignMass(maz);


	allParticles->AddParticle(part);

	/* Make particle 2 */
	particle *part2 = new particle;
	part2->AssignPosition(-1,7,-1);
	part2->AssignVelocity(0,0,0);
	part2->AssignMass(maz);
	allParticles->AddParticle(part2);

	/* Make particle 3 */
	particle *part3 = new particle;
	part3->AssignPosition(0,7,1);
	part3->AssignVelocity(0,0,0);
	part3->AssignMass(maz);
	allParticles->AddParticle(part3);

	/* Make particle 4 */
	particle *part4 = new particle;
	part4->AssignPosition(0,5,0);
	part4->AssignVelocity(0,0,0);
	part4->AssignMass(maz);
	allParticles->AddParticle(part4);

	particle *partc = new particle;
	partc->AssignPosition(0,6,0);
	partc->AssignVelocity(0,0,0);
	partc->AssignMass(maz);
	allParticles->AddParticle(partc);



	allConnections->Connect(part,part2,ks,kd);
	allConnections->Connect(part,part3,ks,kd);
	allConnections->Connect(part2,part3,ks,kd);
	allConnections->Connect(part,part4,ks,kd);
	allConnections->Connect(part2,part4,ks,kd);
	allConnections->Connect(part3,part4,ks,kd);

	allConnections->Connect(partc,part,cks,ckd);
	allConnections->Connect(partc,part2,cks,ckd);
	allConnections->Connect(partc,part3,cks,ckd);
	allConnections->Connect(partc,part4,cks,ckd);


	/* Make one surface on the X-Z plane */
	bounceSurfaces *allSurfaces = new bounceSurfaces;
	allSurfaces->AddSurface(0,0,1,1,0,1,-1,0,-1,friction,resilience);

	float yrot = 0, ztran=0, xrot = 0;
	while(1) {
/*		part4->AssignVelocity(0,0,0);
		part4->AssignPosition(0,5,0);
*/

		for (int i = 0; i < iterations; i++)
		allParticles->EulerStep(dt,allSurfaces,allConnections);

		RGBcolor(0,0,0);
		clear();
		zclear();

		if (getbutton(ESCKEY)) exit(1);
		if (getbutton(AKEY)) yrot+=5;
		if (getbutton(SKEY)) yrot-=5;
		if (getbutton(WKEY)) ztran+=0.5;
		if (getbutton(ZKEY)) ztran-=0.5;
		if (getbutton(EKEY)) xrot+=5;
		if (getbutton(XKEY)) xrot-=5;

		if (getbutton(SPACEKEY)) {
			float xr, yr, zr;

			RandomParts(xr,yr,zr);
			part->AssignPosition(xr,yr,zr);
			part->AssignVelocity(0,0,0);

			RandomParts(xr,yr,zr);
			part2->AssignPosition(xr,yr,zr);
			part2->AssignVelocity(0,0,0);

			RandomParts(xr,yr,zr);
			part3->AssignPosition(xr,yr,zr);
			part3->AssignVelocity(0,0,0);

			RandomParts(xr,yr,zr);
			part4->AssignPosition(xr,yr,zr);
			part4->AssignVelocity(0,0,0);

			RandomParts(xr,yr,zr);
			partc->AssignPosition(xr,yr,zr);
			partc->AssignVelocity(0,0,0);
		}


		pushmatrix();
		translate(0,0,ztran);
		rot(xrot,'X');
		rot(yrot,'Y');

		void DrawFloor();
		DrawFloor();

		RGBcolor(255,255,255);
		bgnpolygon();
		v3f(part->GetPosition());
		v3f(part2->GetPosition());
		v3f(part3->GetPosition());
		v3f(part->GetPosition());
		endpolygon();

		RGBcolor(255,0,0);
		bgnpolygon();
		v3f(part4->GetPosition());
		v3f(part->GetPosition());
		v3f(part2->GetPosition());
		v3f(part4->GetPosition());
		endpolygon();


		RGBcolor(0,0,255);
		bgnpolygon();
		v3f(part4->GetPosition());
		v3f(part2->GetPosition());
		v3f(part3->GetPosition());
		v3f(part4->GetPosition());
		endpolygon();

		RGBcolor(0,255,0);
		bgnpolygon();
		v3f(part4->GetPosition());
		v3f(part3->GetPosition());
		v3f(part->GetPosition());
		v3f(part4->GetPosition());
		endpolygon();
		popmatrix();
		swapbuffers();

	}
	
}



void DrawFloor()
{
	float x,y,z;
	float pt[3];

#define N 5
#define INCGRID 0.5

	RGBcolor(100,0,100);
	for (x = -N; x <= N; x+=INCGRID) {
		bgnline();
		pt[0] = x; pt[1] = 0; pt[2] = -N;
		v3f(pt);
		pt[0] = x; pt[1] = 0; pt[2] = N;
		v3f(pt);
		endline();

		bgnline();
		pt[0] = -N; pt[1] = 0; pt[2] = x;
		v3f(pt);
		pt[0] = N; pt[1] = 0; pt[2] = x;
		v3f(pt);
		endline();
	}

}
